<template>
  <div>
    <div class="flex justify-between items-center">
      <UiButton button-height="sm" color-type="secondary" class="w-12 rounded-16" @click="handleBackClick">
        <img width="24" height="24" src="@/assets/images/ui/ui-arrow-left.svg" />
      </UiButton>
      <p class="text-lg leading-6 font-bold text-txtdprim">{{ $t('configurator.checkout') }}</p>
    </div>
    <div class="checkout-endpoint__invoice mt-8 h-16 rounded-20 flex items-center pl-4 pr-2 gap-2">
      <img width="24" height="24" src="@/assets/images/configurator/zap.svg" />
      <p class="flex-1 text-sm text-txtdprim leading-5 font-medium">{{ $t('configurator.invoice') }}</p>
      <div
        class="checkout-endpoint__invoice-button rounded-16 h-12 w-12 flex items-center justify-center cursor-pointer"
        @mousedown.prevent
        @click="handleInvoiceButtonClick"
      >
        <img width="24" height="24" src="@/assets/images/ui/arrow-right-white.svg" />
      </div>
    </div>
    <div class="rounded-16 bg-bgdtert mt-4 overflow-hidden">
      <div class="h-14 border-b-2 border-bgdsec flex items-center justify-between px-4">
        <p class="font-medium text-sm leading-6 text-txtdsec">{{ $t('configurator.chain') }}:</p>
        <p class="font-medium text-sm leading-6 text-txtdprim">{{ form.chain.title }}</p>
      </div>
      <div class="h-14 border-b-2 border-bgdsec flex items-center justify-between px-4">
        <p class="font-medium text-sm leading-6 text-txtdsec">{{ $t('configurator.network') }}:</p>
        <p class="font-medium text-sm leading-6 text-txtdprim">{{ form.network.title }}</p>
      </div>
      <div class="h-14 border-b-2 border-bgdsec flex items-center justify-between px-4">
        <p class="font-medium text-sm leading-6 text-txtdsec">{{ $t('configurator.mode') }}:</p>
        <p class="font-medium text-sm leading-6 text-txtdprim">{{ $t(`ui-range.${form.mode.key}`) }}</p>
      </div>
      <div class="h-14 flex items-center justify-between px-4">
        <p class="font-medium text-sm leading-6 text-txtdsec">{{ $t('configurator.period') }}:</p>
        <p class="font-medium text-sm leading-6 text-txtdprim">{{ $t(`ui-range.${form.period.key}`) }}</p>
      </div>
    </div>
    <div class="mt-8 px-4 flex items-center justify-between">
      <p class="font-medium text-txtdprim text-lg leading-6">{{ $t('configurator.total') }}:</p>
      <p class="text-txtdprim text-lg leading-6 font-bold">${{ form.total }}.<span class="text-txtdtert">00</span></p>
    </div>
    <UiButton button-height="md" color-type="primary" class="mt-8 xs:mt-8 rounded-24 gap-3" @click="handlePayClick">
      <LoadingSpinner v-if="loading" color-type="white" />
      <template v-else>
        <img width="24" height="24" src="@/assets/images/ui/ui-usd.svg" />
        <p>{{ $t('configurator.pay') }}: ${{ form.total }}.<span style="opacity: 0.32">00</span></p>
      </template>
    </UiButton>
  </div>
</template>

<script lang="ts">
import { web3 } from '@/web3';

import { createProject } from '@/api';
import { getCurrencyInfo } from '@/api/coinapi';

import LoadingSpinner from '@/components/ui/LoadingSpinner.vue';
import UiButton from '@/components/ui/UiButton.vue';

export default {
  name: 'CheckoutEndpoint',

  components: { UiButton, LoadingSpinner },

  props: {
    form: {
      type: Object,
      default: () => ({}),
    },
  },

  data() {
    return {
      buyViaInvoice: false,
      loading: false,
    };
  },

  methods: {
    handleBackClick() {
      this.$emit('update-component', 'CreateEndpoint');
    },

    async handlePayClick() {
      this.loading = true;
      const reqBody = this.createRequestBody();
      try {
        const value = await this.getTransactionValue();

        try {
          await window.ethereum.request({
            method: 'eth_sendTransaction',
            params: [
              {
                from: window.ethereum.selectedAddress,
                to: '0x387A6193C5B54888743F73C3E6d1b6a3145CBae8',
                value: web3.utils.toHex(web3.utils.toWei(value, 'ether')),
                gasLimit: '1000000',
              },
            ],
          });

          window.dataLayer = window.dataLayer || [];
          window.dataLayer.push({
            event: 'payment',
            token: this.form.chain.key,
            amount: value,
            currency: this.$store.state.auth.currentNetwork.key,
          });
        } catch (err) {
          this.$store.dispatch('setErrorPopupDisplay', {
            display: true,
            text: 'deny-transaction',
          });
          throw err;
        }

        await createProject(reqBody);
        window.dataLayer = window.dataLayer || [];
        window.dataLayer.push({
          event: 'new_project',
          token: this.$store.state.auth.walletKey,
        });
        this.$store.commit('setTheConfiguratorDisplay', false);
        this.$store.dispatch('getUserProjects');
      } catch (err) {
        console.error(err);
        console.error('[CreateProject Error]');
      } finally {
        this.loading = false;
      }
    },

    handleInvoiceButtonClick() {
      this.$store.commit('setInvoiceModalDisplay', true);
      this.$store.commit('setTheConfiguratorDisplay', false);
    },

    async getTransactionValue() {
      const res = await getCurrencyInfo(this.$store.state.auth.currentNetwork.key);
      const price = res.data['Realtime Currency Exchange Rate']['5. Exchange Rate'];

      const value = this.form.total / price;
      return String(value);
    },

    createRequestBody() {
      const reqBody = {} as { [key: string]: number | string };

      reqBody.mode = this.form.mode.key;
      reqBody.network = this.form.network.key;
      reqBody.cryptocurrency_symbol = this.form.chain.key;

      const currentDate = new Date();
      let expiredDate;

      if (this.form.period.key === '3d')
        expiredDate = new Date(currentDate.getUTCFullYear(), currentDate.getUTCMonth(), currentDate.getUTCDate() + 3);
      else if (this.form.period.key === '1m')
        expiredDate = new Date(currentDate.getUTCFullYear(), currentDate.getUTCMonth() + 1, currentDate.getUTCDate());
      else if (this.form.period.key === '3m')
        expiredDate = new Date(currentDate.getUTCFullYear(), currentDate.getUTCMonth() + 3, currentDate.getUTCDate());

      reqBody.pay_until = `${expiredDate.getUTCFullYear()}-${
        expiredDate.getUTCMonth() < 9 ? '0' + (expiredDate.getUTCMonth() + 1) : expiredDate.getUTCMonth() + 1
      }-${expiredDate.getUTCDate() < 9 ? '0' + (expiredDate.getUTCDate() + 1) : expiredDate.getUTCDate() + 1}`;

      return reqBody;
    },
  },
};
</script>

<style lang="scss">
.checkout-endpoint {
  &__invoice {
    background: linear-gradient(83.43deg, #9a74f1 3.89%, #fe6f37 55.03%, #fff87a 106.17%);
  }

  &__invoice-button {
    background: rgba(255, 255, 255, 0.32);
    transition: box-shadow 250ms;

    &:hover {
      box-shadow: 0 0 0 2px #f5f5f5 inset;
    }

    &:active {
      transform: scale(0.9);
      box-shadow: 0 0 0 2px #f5f5f5;
    }
  }
}
</style>
